<?php

namespace EventPortal\Domain\Table;

use EventPortal\Concerns\HasWhen;
use EventPortal\Domain\Component\Button;

class GroupedActions
{
    use HasWhen;

    /** @var string */
    public $label;

    /** @var array */
    public $actions = [];

    public function __construct(string $label)
    {
        $this->label = $label;
    }

    public static function make(string $label): self
    {
        return new self($label);
    }

    public function add(callable $callable): self
    {
        $this->actions[] = $callable() instanceof Button ? $callable()->toArray() : $callable();

        return $this;
    }
}
