<?php

namespace EventPortal\Domain\Table;

use EventPortal\Contracts\HasFields;
use EventPortal\Domain\Component\Value;
use EventPortal\Domain\Field\Models\Field;

class TableRow
{
    /** @var GroupedActions */
    public $action;

    public function __construct(HasFields $model)
    {
        $this->setFields($model);
        $this->setActions($model);
    }

    private function setFields(HasFields $model): void
    {
        $model
            ->fields
            ->each(function (Field $field): void {
                $this->{$field->name} = Value::get(
                    optional($field->response)->value,
                    $field->type->isSlideToggle()
                );
            });
    }

    private function setActions(HasFields $model): void
    {
        $this->action = $model->tableActions();
    }
}
