<?php

namespace EventPortal\Tests\Unit\Util;

use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Form\Exceptions\NoDefaultFound;
use EventPortal\Domain\Util\DefaultConfig;
use EventPortal\Tests\TestCase;

class DefaultConfigTest extends TestCase
{
    /** @test **/
    public function get_config_for_table_columns()
    {
        config()->set('defaults.event.tableColumns', ['name', 'url']);

        $actual = DefaultConfig::for(Event::class)->tableColumns();

        $this->assertEquals(['name', 'url'], $actual);
    }

    /** @test **/
    public function exception_thrown_when_no_config()
    {
        $this->expectException(NoDefaultFound::class);

        config()->set('defaults.event.tableColumns', null);
        config()->set('defaults.event.fields', null);

        DefaultConfig::for(Event::class)->tableColumns();
    }
}
